﻿using Selenium;

namespace SeleniumToolkit.Core
{
    /// <summary>
    /// Provides creation facility for creating custom selenium instances
    /// </summary>
    /// <remarks>
    /// The SeleniumFactory uses a ISeleniumFactoryProvider to create selenium instances.
    /// </remarks>
    public interface ISeleniumFactoryProvider
    {
        /// <summary>
        /// Creates a Selenium Browser instance
        /// </summary>
        /// <param name="serverHost"></param>
        /// <param name="serverPort"></param>
        /// <param name="browserProfile"></param>
        /// <param name="baseUrl"></param>
        /// <returns></returns>
        ISelenium Create(string serverHost, int serverPort, string browserProfile, string baseUrl);
    }
}
