﻿namespace SeleniumToolkit.Core
{
    /// <summary>
    /// Defines a contract of settings carried by tests and fixtures
    /// </summary>
    public interface ISessionInfo
    {
        /// <summary>
        /// Browser Timeout
        /// </summary>
        string Timeout { get; set; }

        /// <summary>
        /// Default Browser String
        /// </summary>
        string DefaultBrowser { get; set; }

        /// <summary>
        /// Base URL for a test fixture or test
        /// </summary>
        string BaseUrl { get; set; }

        /// <summary>
        /// Flag to determine if the settings holder owns the lifecycle of the process
        /// </summary>
        bool SessionOwner { get; set; }
    }
}
