﻿using System;
using System.Runtime.Serialization;

namespace SeleniumToolkit.Core
{
    /// <summary>
    /// Represents a user-defined runtime error when configuration settings cannot be inferred.
    /// </summary>
    public class MissingSeleniumConfigurationException : Exception
    {
        #region Constructors
        /// <summary>
        /// Default Constructor
        /// </summary>
        public MissingSeleniumConfigurationException()
        {
        }

        /// <summary>
        /// Constructor with Message
        /// </summary>
        /// <param name="message">descriptive message</param>
        public MissingSeleniumConfigurationException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Constructor with Message and Wrapped Exception
        /// </summary>
        /// <param name="message">descriptive message</param>
        /// <param name="innerException">exception to wrap</param>
        public MissingSeleniumConfigurationException(string message, Exception innerException)
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Serialization Constructor
        /// </summary>
        /// <param name="info"></param>
        /// <param name="context"></param>
        protected MissingSeleniumConfigurationException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        } 
        #endregion
    }
}
